﻿* Encoding: UTF-8.
*Multiple Response tools
*SPSS macros by Kirill Orlov
*kior@comtv.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_REGMRC*/vers3*************************************************************************.
define !KO_regmrc(vars= !charend('/') /nvars= !charend('/') /check= !charend('/') /sole= !charend('/') /random= !charend('/') /crop= !charend('/')
                 /filler= !charend('/') /selfexe= !charend('/'))
!if (!tail(!check)<>!null) !then !let !codes= !null
 !do !w !in (!tail(!check)) 
  !if (!w<>'EXCEPT') !then !let !codes= !concat(!codes,',',!w) !ifend
 !doend
 !let !codes= !concat('any(mrc$$$$$(#i$$$$$)',!codes,') and')
 !if (!head(!tail(!check))='EXCEPT') !then !let !codes= !concat('not ',!codes) !ifend
!ifend
!if (!crop='YES' !and !selfexe='NO') !then
-echo ''.
-echo '>ERROR. CROP=YES is impossible with SELFEXE=NO.'.
-echo '>!KO_REGMRC is not executed.'.
!else !if (!sole<>!null !and !tail(!sole)=!null) !then
-echo '>ERROR. After SOLE=DELETE/LEAVE there must be value list.'.
-echo '>!KO_REGMRC is not executed.'.
!else !if (!head(!check)='NO' !and !tail(!check)<>!null) !then
-echo ''.
-echo '>ERROR. CHECK=NO cannot be followed by value list.'.
-echo '>!KO_REGMRC is not executed.'.
!else
-count #nv$$$$$= !vars (lo thru hi sysmis).
 !if (!nvars<>!null) !then
- do if $casenum=1.
-  do if #nv$$$$$=!nvars.
-   comp #nv_$$$$$= 1.
-  else.
-   comp #nv_$$$$$= 0.
-   print /' ' /'>WARNING. Specified NVARS is not equal to the actual number of variables.'
          /'>If you requested CHECK=YES, deleting of code duplicates will not be done.'.
-  end if.
- end if.
 !ifend
-set errors none.
-vector mrc$$$$$= !vars.
-set errors list.
-do if nvalid(!vars)>0.
  !if (!sole<>!null) !then
-  do rep sole= !tail(!sole).
-   do if any(sole,!vars).
     !if (!head(!sole)='LEAVE') !then
-     recode !vars (sole=copy) (else=sysmis).
     !else
-     count #cnt$$$$$= !vars (sole).
-     do if #cnt$$$$$<nvalid(!vars).
-      recode !vars (sole=sysmis).
-     end if.
     !ifend
-   end if.
-  end rep.
  !ifend
  !if (!head(!check)='YES') !then
   !if (!nvars=!null) !then
-   loop #i$$$$$= 1 to #nv$$$$$-1.
-    loop #j$$$$$= #i$$$$$+1 to #nv$$$$$.
-     if !codes mrc$$$$$(#i$$$$$)=mrc$$$$$(#j$$$$$) mrc$$$$$(#j$$$$$)= $sysmis.
-    end loop.
-   end loop.
   !else
-   do if #nv_$$$$$.
-    vector #lst$$$$$(!nvars).
-    recode #lst$$$$$1 to !conc('#lst$$$$$',!nvars) (else=-1.0028458631976E300).
-    loop #i$$$$$= 1 to #nv$$$$$.
-     do if !codes any(mrc$$$$$(#i$$$$$),#lst$$$$$1 to !conc('#lst$$$$$',!nvars)).
-      comp mrc$$$$$(#i$$$$$)= $sysmis.
-     else.
-      comp #lst$$$$$(#i$$$$$)= mrc$$$$$(#i$$$$$).
-     end if.
-    end loop.
-   end if.
   !ifend
  !ifend
- comp #i$$$$$= 1.
- loop #j$$$$$= 1 to #nv$$$$$.
-  do if not miss(mrc$$$$$(#j$$$$$)).
-   comp mrc$$$$$(#i$$$$$)= mrc$$$$$(#j$$$$$).
-   comp #i$$$$$= #i$$$$$+1.
-  end if.
- end loop.
- loop #j$$$$$= #i$$$$$ to #nv$$$$$.
-  comp mrc$$$$$(#j$$$$$)= !if (!filler<>!null) !then !filler !else $sysmis !ifend.
- end loop.
  !if (!random='YES') !then
-  loop #i$$$$$= #i$$$$$-1 to 2 by -1.
-   comp #j$$$$$= trunc(unif(1)*#i$$$$$)+1.
-   comp #tmp$$$$$= mrc$$$$$(#i$$$$$).
-   comp mrc$$$$$(#i$$$$$)= mrc$$$$$(#j$$$$$).
-   comp mrc$$$$$(#j$$$$$)= #tmp$$$$$.
-  end loop.
  !ifend
-end if.
 !if (!crop='YES') !then
  !if (!filler<>!null) !then
-  echo ''.
-  echo '>REMINDER. FILLER value should be user-missing in order CROP=YES'.
-  echo ' to delete all the empty variables.'.
  !ifend
- dataset decl crop$$$$$._ window= hidden.
- comp z0$$$$$._= 1.
- OMS /SELECT TABLES /IF COMMANDS=['Descriptives'] SUBTYPES=['Descriptive Statistics']
    /DESTINATION FORMAT=SAV OUTFILE='crop$$$$$._' VIEWER=NO.
- OMS /SELECT TABLES /IF SUBTYPES=['NOTES'] /DESTINATION VIEWER=NO.
- temp.
- split file off.
- filter off.
- weight off.
- preserve.
- set tvars= names.
- descr !vars /stat= min.
- restore.
- OMSEND.
- match files file= * /file= crop$$$$$._
    /rename (all = z1$$$$$._ z2$$$$$._ z3$$$$$._ z4$$$$$._ z5$$$$$._ z6$$$$$._).
- dataset close crop$$$$$._.
- do if $casenum=1.
-  write outfile= 'temp_KO_regmrc.sps' /'del vari'.
- else if z4$$$$$._<>'Valid N (listwise)' and z5$$$$$._=0.
-  write outfile= 'temp_KO_regmrc.sps' /' ' z4$$$$$._.
- end if.
- select if z0$$$$$._=1.
- exec.
- insert file= 'temp_KO_regmrc.sps' syntax= batch.
- del vari z0$$$$$._ z1$$$$$._ z2$$$$$._ z3$$$$$._ z4$$$$$._ z5$$$$$._ z6$$$$$._.
- erase file= 'temp_KO_regmrc.sps'.
 !ifend
 !if (!selfexe<>'NO') !then
- exec.
 !ifend
!ifend !ifend !ifend
!enddefine.

*/*!KO_MRDNA*/*************************************************************************.
define !KO_mrdna(separ= !charend('/') /namend= !charend('/') /labels= !charend('/') /regist= !charend('/') /sets= !cmdend)
!let !sep= !unquote(!separ)
!if (!substr(!sets,!length(!sets))<>'/') !then !let !list= !concat(!sets,'/') !else !let !list= !sets !ifend
!if (!tail(!regist)<>!null) !then !let !labs= !tail(!regist) !ifend
!do !i= 1 !to 999
 !let !ind= !index(!list,'/')
 !if (!ind=0) !then !break !ifend
 !let !set= !substr(!concat(' ',!list),1,!ind) !let !list= !tail(!substr(!list,!ind))
 !if (!upcase(!head(!tail(!set)))<>'TO') !then !let !st= !null
  !do !w !in (!set)
   !let !st= !concat(!st,',',!w)
  !doend
  !let !st= !tail(!st)
 !else !let !st= !set
 !ifend
 !let !nam= !head(!set) !let !namhead= !null !let !err= !null
 !if (!separ=!null) !then !let !namhead= !nam
 !else
  !if (!separ="''" !or !separ='""') !then
   !do !i2= !length(!nam) !to 1 !by -1
    !if (!index('0123456789',!substr(!nam,!i2,1))=0) !then !let !namhead= !substr(!nam,1,!i2) !break !ifend
   !doend
   !if (!length(!namhead)=!length(!nam)) !then !let !err= !concat('>ERROR. SEPAR="", but no number found to end name ',!nam,'.') !ifend
  !else
   !do !i2= !length(!nam) !to 2 !by -1
    !if (!substr(!nam,!i2,1)=!sep) !then !let !namhead= !head(!substr(!concat(' ',!nam),1,!i2)) !break !ifend
   !doend
   !if (!namhead=!null) !then !let !err= !concat('>ERROR. Separator SEPAR not found in name ',!nam,'.') !ifend
  !ifend
 !ifend
 !if (!err<>!null) !then
- do if $casenum=1.
-  print /!quote(!err) /'         Macro will skip this set.'.
- end if.
- exec.
 !else
- do if nvalid(!st)>0.
-  comp !concat(!namhead,!sep,!namend)= 0.
-  if sum(!st)=0 !concat(!namhead,!sep,!namend)= 1.
- end if.
- format !set !concat(!namhead,!sep,!namend) (f1).
  !if (!labels<>!null) !then
-  var lab !concat(!namhead,!sep,!namend) !head(!labels).
   !if (!tail(!labels)<>!null) !then
-   val lab !concat(!namhead,!sep,!namend) !tail(!labels).
   !ifend
  !ifend
  !if (!head(!regist)='YES') !then
   !if (!tail(!regist)<>!null) !then !let !setlab= !concat('label=',!head(!labs)) !let !labs= !tail(!labs) !ifend
-  mrset /mdgroup name= !concat('$',!namhead) !setlab vari= !set !concat(!namhead,!sep,!namend) value= 1.
  !ifend
 !ifend
!doend
exec.
!enddefine.

*/*!KO_DONRECI*/vers3*************************************************************************.
define !KO_donreci(recip= !charend('/') /donat= !charend('/') /clean= !charend('/') /values= !charend('/') /suffic= !charend('/')
                  /report= !charend('/') /valrand= !charend('/') /replace= !charend('/') /bases= !charend('/') /noans= !charend('/') /selfexe= !charend('/'))
!let !ok= 1
!if (!index(!values,'-')>0) !then !let !ok= 0
-echo ''.
-echo '>ERROR. VALUES cannot contain negative values.'.
!else !if (!index(!values,' EXCEPT')>0 !and !upcase(!head(!tail(!values)))<>'TO') !then !let !ok= 0
-echo ''.
-echo '>ERROR. VALUES has keyword EXCEPT, but TO on position two is missing.'.
!else !if (!index(!upcase(!recip),' TO ')>0 !and !tail(!tail(!tail(!recip)))<>!null
       !or !index(!upcase(!donat),' TO ')>0 !and !tail(!tail(!tail(!donat)))<>!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. RECIP/DONAT can be specified either as list or via TO, but not mixed.'.
!else !if (!head(!clean)='RECODE') !then !let !newvalues= !tail(!clean)
 !if (!newvalues=!null) !then !let !ok= 0
- echo ''.
- echo '>ERROR. After CLEAN=RECODE there must be value list.'.
 !else !if (!index(!newvalues,'-')>0) !then !let !ok= 0
- echo ''.
- echo '>ERROR. In the list after CLEAN=RECODE there can be no negative values.'.
 !else !if (!index(!newvalues,' EXCEPT')>0 !and !upcase(!head(!tail(!newvalues)))<>'TO') !then !let !ok= 0
- echo ''.
- echo ">ERROR. In the list after CLEAN=RECODE there's keyword EXCEPT but no TO on position two.".
 !else !if (!index(!newvalues,'ALL')>0 !and !tail(!newvalues)<>' ALL') !then !let !ok= 0
- echo ''.
- echo ">ERROR. If in the list after CLEAN=RECODE there's keyword ALL, single number must be before it.".
 !ifend !ifend !ifend !ifend
!ifend !ifend !ifend !ifend
!if (!ok) !then
 !let !cln= !head(!clean) !let !clnna= 0 !let !clnnr= 0 !let !rep= 0
 !if (!cln='CHOOSE') !then !let !elser= 'else' !let !endifr= 'end if'
  !if (!tail(!clean)=!null) !then !let !ifr= 'do if uniform(1)>=.5' !else !let !ifr= !conc('do if uniform(1)>=',!tail(!clean)) !ifend
 !ifend
 !if (!cln<>'ADD' !and !cln<>!null) !then !let !clnna= 1 !ifend
 !if (!cln<>'REMOVE' !and !cln<>'RECODE') !then !let !clnnr= 1 !ifend
 !if (!report='YES') !then !let !rep= 1 !ifend
 !if (!suffic<>!null !and !newvalues=!null) !then
  !let !scond= !conc('and #s$$$$$<rnd(',!suffic,')') !let !suff0= 'comp #s$$$$$= 0' !let !suff= 'comp #s$$$$$= #s$$$$$+1'
 !ifend
 !if (!upcase(!head(!tail(!recip)))<>'TO') !then !let !rcp= !null
  !do !w !in (!recip) !let !rcp= !conc(!rcp,',',!w) !doend
  !let !rcp= !tail(!rcp)
 !else !let !rcp= !recip
 !ifend
 !if (!upcase(!head(!tail(!donat)))<>'TO') !then !let !dnt= !null
  !do !w !in (!donat) !let !dnt= !conc(!dnt,',',!w) !doend
  !let !dnt= !tail(!dnt)
 !else !let !dnt= !donat
 !ifend
 !if (!upcase(!head(!tail(!values)))='TO') !then !let !vals= !null
  !if (!head(!tail(!tail(!tail(!values))))='EXCEPT') !then !let !except= !tail(!tail(!tail(!tail(!values)))) !ifend
  !do !i= !head(!values) !to !head(!tail(!tail(!values)))
   !if (!index(!conc(!except,' '),!conc(' ',!i,' '))=0) !then !let !vals= !conc(!vals,' ',!i) !ifend
  !doend
 !else !let !vals= !values
 !ifend
 !let !nvals= !null
 !do !w !in (!vals) !let !nvals= !conc(!nvals,' ') !doend
 !let !nvals= !len(!nvals)
 !if (!newvalues<>!null) !then !let !newvals= !null
  !if (!tail(!newvalues)=' ALL') !then !let !newval= !head(!newvalues)
   !do !i= 1 !to !nvals !let !newvals= !conc(!newvals,' ',!newval) !doend
  !else !if (!upcase(!head(!tail(!newvalues)))='TO') !then
   !if (!head(!tail(!tail(!tail(!newvalues))))='EXCEPT') !then !let !except= !tail(!tail(!tail(!tail(!newvalues)))) !ifend
   !do !i= !head(!newvalues) !to !head(!tail(!tail(!newvalues)))
    !if (!index(!conc(!except,' '),!conc(' ',!i,' '))=0) !then !let !newvals= !conc(!newvals,' ',!i) !ifend
   !doend
  !else !let !newvals= !newvalues
  !ifend !ifend
  !let !newvalues= !null
  !do !w !in (!newvals) !let !newvalues= !conc(!newvalues,' ') !doend !let !newvalues= !len(!newvalues)
  !if (!newvalues<>!nvals) !then !let !ok= 0
-  echo ''.
-  echo '>ERROR. Value lists VALUES and by CLEAN=RECODE are different length.'.
  !ifend
 !ifend
!ifend
!if (!ok) !then
 !if (!newvals<>!null !and (!suffic<>!null !or !valrand='YES')) !then
- echo ''.
- echo '>WARNING. With CLEAN=RECODE subcommands SUFFIC and VALRAND are ignored.'.
 !ifend
 !if (!valrand='YES' !and !newvals=!null) !then
  !let !loop= !conc('loop #i$$$$$= 1 to ',!nvals) !let !endloop= 'end loop'
  !let !doif= !conc('do if #v$$$$$(#i$$$$$)=',!head(!vals)) !let !endif= 'end if'
- set errors none.
- vector #v$$$$$ (!nvals).
- set errors list.
 !ifend
 !if (!report='YES') !then !let !rem= 'comp remove_= remove_+1' !let !add= 'comp add_= add_+1'
- comp remove_= $sysmis.
- comp add_= $sysmis.
- comp addfail_= $sysmis.
- format remove_ add_ addfail_ (f8).
 !ifend
 !if (!bases='INTERSECT') !then
- do if nvalid(!rcp)>0 and nvalid(!dnt)>0.
 !else
- do if nvalid(!rcp,!dnt)>0.
 !ifend
 !if (!valrand='YES' !and !newvals=!null) !then
-  do rep v= #v$$$$$1 to !conc('#v$$$$$',!nvals) /val= !vals.
-   comp v= val.
-  end rep.
-  loop #i$$$$$= !nvals to 2 by -1.
-   comp #j$$$$$= trunc(unif(1)*#i$$$$$)+1.
-   comp #tmp$$$$$= #v$$$$$(#i$$$$$).
-   comp #v$$$$$(#i$$$$$)= #v$$$$$(#j$$$$$).
-   comp #v$$$$$(#j$$$$$)= #tmp$$$$$.
-  end loop.
 !ifend
-  !suff0.
   !if (!report='YES') !then
-   comp remove_= 0. 
-   comp add_= 0.
-   comp addfail_= 0.
   !ifend
-  !loop.
-   !doif.
     !do !val !in (!vals)
      !let !newval= !head(!newvals) !let !newvals= !tail(!newvals)
      !if (!valrand='YES' !and !val<>!head(!vals) !and !newval=!null) !then
-      else if #v$$$$$(#i$$$$$)=!val.
      !ifend
-       !ifr.
        !if (!clnna) !then
-        do if any(!val,!rcp) and (not any(!val,!dnt) or nvalid(!dnt)=0) !scond.
-         recode !recip (!val=!if (!newval=!null) !then sysmis !else !newval !ifend).
-         !suff.
-         !rem.
-        end if.
        !ifend
-       !elser.
        !if (!clnnr) !then
-        comp #d$$$$$= 0.
-        do if any(!val,!dnt) and (not any(!val,!rcp) or nvalid(!rcp)=0) !scond.
-         do rep recip= !recip.
-          do if not #d$$$$$.
-           recode recip (!replace miss=!val).
-           do if value(recip)=!val.
-            comp #d$$$$$= 1.
-            !suff.
-            !add.
-           end if.
-          end if.
-         end rep.
          !if (!rep) !then
-          comp addfail_= addfail_+not any(!val,!rcp).
          !ifend
-        end if.
        !ifend
-       !endifr.
     !doend
-   !endif.
-  !endloop.
   !if (!report='YES' !and !suffic<>!null !and !cln<>'REMOVE' !and !cln<>'RECODE') !then
-   if add_+addfail_>rnd(!suffic) addfail_= rnd(!suffic)-add_.
   !ifend
   !if (!noans<>!null) !then
-   if nvalid(!rcp)=0 !head(!recip)= !noans.
   !ifend
-end if.
 !if (!selfexe<>'NO') !then
- exec.
 !ifend
!else
-echo '>!KO_DONRECI is not executed.'.
!ifend
!enddefine.

*/*!KO_STRMRC*/*************************************************************************.
define !KO_strmrc(strvar= !charend('/') /pack= !charend('/') /check= !charend('/') /eqcase= !charend('/') /categs= !charend('/')
              /codes= !charend('/') /limit= !charend('/') /filler= !charend('/') /noans= !charend('/') /separ= !charend('/') /regist= !charend('/')
              /pm= !charend('/') !default('+'))
!let !ok= 1 !let !sep= !unquote(!separ) !let !na= !noans !let !fill= !filler
!if (!upcase(!head(!tail(!categs)))='TO') !then !let !ctg= !null !let !lim= !null
 !if (!head(!tail(!tail(!tail(!categs))))='EXCEPT') !then !let !except= !tail(!tail(!tail(!tail(!categs)))) !ifend
 !do !i= !head(!categs) !to !head(!tail(!tail(!categs)))
  !if (!index(!concat(!except,' '),!concat(' ',!i,' '))=0) !then
   !let !ctg= !concat(!ctg,' ',!i) !let !lim= !concat(!lim,' ')
  !ifend
 !doend
 !let !lim= !length(!lim)
!else !let !ctg= !concat(' ',!categs) !let !ctg2= !ctg !let !ind= 1
 !do !lim= 1 !to 999
  !let !ctg2= !substr(!ctg2,!length(!concat(!blanks(!ind),' '))) !let !ind= !index(!ctg2,' ')
  !if (!ind=0) !then !break !ifend
 !doend
!ifend
!if (!eqcase<>'NO') !then !let !ctg= !concat(!upcase(!ctg),' ') !let !up1= 'upcase(' !let !up2= ')'
!else !let !ctg= !concat(!ctg,' ')
!ifend
!if (!codes='SAME') !then !let !cds= !ctg !let !rspec= '(convert)'
!else
 !if (!codes<>!null) !then !let !ctg2= !ctg !let !cds= !codes !let !rspec= !null
  !do !i= 1 !to !lim
   !let !ind= !index(!substr(!ctg2,2),' ')
   !let !cat= !substr(!ctg2,1,!ind) !let !cat= !substr(!cat,2) !let !ctg2= !substr(!ctg2,!length(!concat(!blanks(!ind),' ')))
   !let !cod= !head(!cds) !let !cds= !tail(!cds)
   !let !rspec= !concat(!rspec,' ',!concat('(',!quote(!cat),'=',!cod,')'))
  !doend
  !if (!cod=!null !or !cds<>!null) !then !let !ok= 0
-  do if $casenum=1.
-   print /'>ERROR. Lists CATEGS and CODES are of different length.'.
-  end if.
  !else !let !cds= !codes
  !ifend
 !else !let !rspec= '(else=copy)'
  !if (!fill=!null) !then !let !fill= ' ' !ifend
  !let !na= !quote(!na) !let !fill= !quote(!fill)
 !ifend
!ifend
!if (!ok) !then
 !let !pm1= !quote(!concat(' ',!pm)) !let !pm2= '," "'
 !do !i= 1 !to !length(!pm)
  !let !pm2= !concat(!pm2,',',!quote(!substr(!pm,!i,1)))
 !doend
 !if (!limit<>!null) !then !let !lim= !limit !ifend
 !if (!codes=!null) !then
- string !concat(!strvar,!sep,1) to !concat(!strvar,!sep,!lim) (a8).
 !else
  !if (!index(!concat(!codes,!noans,!filler),'.')=0) !then !let !f= '(f8)' !ifend
- numer !concat(!strvar,!sep,1) to !concat(!strvar,!sep,!lim) !f.
- var lev !concat(!strvar,!sep,1) to !concat(!strvar,!sep,!lim) (nomin).
 !ifend
-string #med1 to !concat('#med',!lim) (a8).
-comp #len= length(rtrim(!strvar)).
-comp #ind= 1.
-comp #cind= 1.
-comp #width= 1.
-comp #incr= 1.
 !if (!pack='FREE') !then !let !add= '+1' !ifend
 !if (!pack='DISPART') !then !let !indent= '-#width+1' !ifend
 !do !i= 1 !to !lim
- comp !concat('#med',!i)= ' '.
- loop #i= 1 to #len if #ind<=#len !indent and !concat('#med',!i)=' '.
-  do if not any(substr(!strvar,#ind,1)!pm2).
    !if (!pack='FREE') !then
-    comp #width= index(concat(substr(!strvar,#ind),' '),!pm1,1)-1.
    !ifend
-   do if index(!quote(!ctg),concat(' ',!up1 substr(!strvar,#ind,#width) !up2,' '))>0.
     !if (!check<>'NO') !then
      !if (!i>1) !then !let !tomed= !concat('to #med',!i) !ifend
-     if not any(!up1 substr(!strvar,#ind,#width) !up2,#med1 !tomed) !concat('#med',!i)= !up1 substr(!strvar,#ind,#width) !up2.
     !else
-     comp !concat('#med',!i)= !up1 substr(!strvar,#ind,#width) !up2.
     !ifend
-   end if.
    !if (!pack='DISPART') !then
-    do if #width=2 and #cind=1.
-     comp #cind= #ind.
-     comp #incr= 2.
-    end if.
    !ifend
-   comp #ind= #ind+#width !add.
-  else.
-   comp #ind= #ind+#incr.
    !if (!pack='DISPART') !then
-    comp #width= 2.
    !ifend
-  end if.
- end loop.
 !doend
 !if (!filler<>!null) !then !let !rfill= !concat('(" "=',!fill,')') !ifend
 !if (!codes=!null) !then
- recode #med1 to !concat('#med',!lim) !rfill (else=copy) into !concat(!strvar,!sep,1) to !concat(!strvar,!sep,!lim).
 !else !let !sysmis= 'sysmis'
- recode #med1 to !concat('#med',!lim) !rfill !rspec into !concat(!strvar,!sep,1) to !concat(!strvar,!sep,!lim).
 !ifend
 !if (!noans<>!null) !then
- recode !concat(!strvar,!sep,1) (!fill !sysmis=!na).
 !ifend
-miss val !concat(!strvar,!sep,1) to !concat(!strvar,!sep,!lim) (!fill).
 !if (!filler=!noans !and !filler<>!null) !then
- miss val !concat(!strvar,!sep,1) ().
 !ifend
 !if (!head(!regist)='YES') !then
  !if (!tail(!regist)<>!null) !then !let !setlab= !concat('label=',!tail(!regist)) !ifend
- mrset /mcgroup name= !concat('$',!strvar) !setlab vari= !concat(!strvar,!sep,1) to !concat(!strvar,!sep,!lim).
 !ifend
!ifend
exec.
!enddefine.

*/*!KO_STRMRD*/*************************************************************************.
define !KO_strmrd(strvar= !charend('/') /pack= !charend('/') /eqcase= !charend('/') /categs= !charend('/')
              /indxs= !charend('/') /noans= !charend('/') /separ= !charend('/') /regist= !charend('/')
              /pm= !charend('/') !default('+;'))
!let !sep= !unquote(!separ)
!if (!upcase(!head(!tail(!categs)))='TO') !then !let !ctg= !null !let !lim= !null
 !if (!head(!tail(!tail(!tail(!categs))))='EXCEPT') !then !let !except= !tail(!tail(!tail(!tail(!categs)))) !ifend
 !do !i= !head(!categs) !to !head(!tail(!tail(!categs)))
  !if (!index(!concat(!except,' '),!concat(' ',!i,' '))=0) !then
   !let !ctg= !concat(!ctg,' ',!i) !let !lim= !concat(!lim,' ')
  !ifend
 !doend
 !let !ctg= !substr(!ctg,2) !let !lim= !length(!lim)
!else !let !ctg= !categs !let !ctg2= !concat(' ',!categs) !let !ind= 1
 !do !lim= 1 !to 999
  !let !ctg2= !substr(!ctg2,!length(!concat(!blanks(!ind),' '))) !let !ind= !index(!ctg2,' ')
  !if (!ind=0) !then !break !ifend
 !doend
!ifend
!if (!eqcase<>'NO') !then !let !ctg= !concat(!upcase(!ctg),'  ') !let !up1= 'upcase(' !let !up2= ')'
!else !let !ctg= !concat(!ctg,'  ')
!ifend
!if (!indxs='SAME') !then !let !indx= !ctg !else !let !indx= !indxs !ifend
!let !cnt= !null !let !vars= !null !let !vars2= !null
!do !w !in (!indx)
 !let !cnt= !concat(!cnt,' ')
 !let !vars= !concat(!vars,' ',!strvar,!sep,!w)
 !let !vars2= !concat(!vars2,',',!strvar,!sep,!w)
!doend
!if (!length(!cnt)<>!lim) !then
-do if $casenum=1.
- print /'>ERROR. Lists CATEGS and INDXS differ in length or INDXS are not solid "words".'.
-end if.
!else
 !let !pm1= !quote(!concat(' ',!pm)) !let !pm2= '," "'
 !do !i= 1 !to !length(!pm)
  !let !pm2= !concat(!pm2,',',!quote(!substr(!pm,!i,1)))
 !doend
-numer !vars !if (!noans<>!null) !then !concat(!strvar,!sep,!noans) !ifend (f1).
-var lev !vars !if (!noans<>!null) !then !concat(!strvar,!sep,!noans) !ifend (ord).
-recode !vars (else=0).
-do if !strvar<>' '.
  !if (!pack='DISPART') !then
-  comp #fd= index(rtrim(!strvar),!pm1,1).
-  do if #fd=0.
-   comp #fd= length(rtrim(!strvar))+1.
-  else.
-   loop #fd= #fd to length(rtrim(!strvar)).
-   end loop if not any(substr(!strvar,#fd,1)!pm2).
-  end if.
  !ifend
  !do !var !in (!vars)
   !let !code= !substr(!concat(' ',!ctg),1,!index(!ctg,' ')) !let !code= !substr(!code,2)
   !let !wid= !length(!code) !let !code= !quote(!code)
   !let !ctg= !substr(!substr(!ctg,!index(!ctg,' ')),2)
   !if (!pack='DISPART') !then
    !if (!wid=2) !then
-    do if #fd<length(rtrim(!strvar)).
-     comp #ind= #fd.
-     loop #i= 1 to length(!strvar) if length(substr(!strvar,#ind))>=2.
-      comp #i= index(!up1 substr(!strvar,#ind) !up2,!code).
-      do if #i>0.
-       comp !var= mod(#ind+#i-#fd,2).
-       comp #ind= #ind+#i.
-      end if.
-     end loop if #i=0 or !var.
-    end if.
    !else
-    comp !var= index(!up1 substr(!strvar,1,#fd-1) !up2,!code)>0.
    !ifend
   !ifend
   !if (!pack='FREE') !then
-   comp #ind= 1.
-   loop #i= 1 to length(!strvar) if length(substr(!strvar,#ind))>=!wid.
-    comp #i= index(!up1 substr(!strvar,#ind) !up2,!code).
-    do if #i>0.
-     comp !var= any(substr(concat(' ',substr(!strvar,#ind)),#i,1)!pm2) and any(substr(concat(substr(!strvar,#ind),' '),#i+!wid,1)!pm2).
-     comp #ind= #ind+#i+!wid.
-    end if.
-   end loop if #i=0 or !var.
   !ifend
   !if (!pack='ONECHAR') !then
-   comp !var= index(!up1 !strvar !up2,!code)>0.
   !ifend
  !doend
-end if.
 !if (!noans<>!null) !then
- comp !concat(!strvar,!sep,!noans)= sum(!tail(!vars2))=0.
 !ifend
 !if (!head(!regist)='YES') !then
  !if (!tail(!regist)<>!null) !then !let !setlab= !concat('label=',!tail(!regist)) !ifend
- mrset /mdgroup name= !concat('$',!strvar) !setlab vari= !vars !if (!noans<>!null) !then !concat(!strvar,!sep,!noans) !ifend val= 1.
 !ifend
!ifend
exec.
!enddefine.

*/*!KO_ERRDISP*/****************************************************************.
define !KO_errdisp(vars= !charend('/') /id= !charend('/') /pm= !charend('/') !default('+'))
!if (!id=!null) !then !let !idd= '$casenum' !else !let !idd= !id !ifend
!let !pm1= !quote(!concat(' ',!pm)) !let !pm2= '," "'
!do !i= 1 !to !length(!pm) !let !pm2= !concat(!pm2,',',!quote(!substr(!pm,!i,1))) !doend
do if $casenum=1.
-print /'CASES WITH ERRORS OF DATA ENTRY (check of DISPART type entry)' /'In questions with no cases listed errors are not found'.
end if.
!do !var !in (!vars)
-do if $casenum=1.
- print space.
- print /!quote(!concat('Question ',!upcase(!var))) /!quote(!upcase(!idd)).
-end if.
-do if !var<>' '.
- comp #ind= index(rtrim(!var),!pm1,1).
- do if #ind>0.
-  loop #i= #ind to length(rtrim(!var)).
-   do if not any(substr(!var,#i,1)!pm2).
-    do if index(substr(rtrim(!var),#i),!pm1,1)>0 or mod(length(substr(rtrim(!var),#i)),2).
-     print /!idd.
-    end if.
-    break.
-   end if.
-  end loop.
- else if length(rtrim(!var))>1.
-  loop #i= 1 to length(rtrim(!var)).
-   do if rindex(!var,substr(!var,#i,1))>#i.
-    print /!idd.
-    break.
-   end if.
-  end loop.
- end if.
-end if.
-exec.
!doend
!enddefine.
